"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Lint = require("tslint");
var AstUtils_1 = require("./utils/AstUtils");
var NoNewBufferWalker = /** @class */ (function (_super) {
    __extends(NoNewBufferWalker, _super);
    function NoNewBufferWalker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NoNewBufferWalker.prototype.visitNewExpression = function (node) {
        // Get name of class that's being created
        var name = AstUtils_1.AstUtils.getFunctionName(node);
        if (name === "Buffer") {
            // create a failure at the current position
            // tslint:disable-next-line
            this.addFailure(this.createFailure(node.getStart(), node.getWidth(), Rule.FAILURE_STRING));
        }
        // call the base version of this visitor to actually parse this node
        _super.prototype.visitNewExpression.call(this, node);
    };
    return NoNewBufferWalker;
}(Lint.RuleWalker));
var Rule = /** @class */ (function (_super) {
    __extends(Rule, _super);
    function Rule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Rule.prototype.apply = function (sourceFile) {
        return this.applyWithWalker(new NoNewBufferWalker(sourceFile, this.getOptions()));
    };
    Rule.FAILURE_STRING = "new Buffer() is deprecated, use Buffer.from() instead";
    return Rule;
}(Lint.Rules.AbstractRule));
exports.Rule = Rule;
//# sourceMappingURL=aaaNoNewBufferRule.js.map